/*!
 <PRE>
 SOURCE FILE : listaenc.cpp
 DESCRIPTION.: Implementacao da lista encadeada nao ordenada
 AUTHOR......: Raul Joaquim Camara dos Santos
 LOCATION....: DIMAp/UFRN.
 STARTED ON.: Setembro/2007

 TO COMPILE..: g++ -Wall orca.cpp -o orca
 LAST UPDATE.: 19 de setembro de 2007.
 </pre>
*/
/* ========================================================================= */
/* INCLUDES   	 				                             */
/* ------------------------------------------------------------------------- */
#include "listaenc.h"
	
	//!construtor da lista com ptlista inicializado com NULL 
	ListaEnc::ListaEnc(): ptlista(NULL) 
       {}
	
	ListaEnc::~ListaEnc() //destrutor da lista
       { 
	NoLista* pAtual = ptlista; 
	while(pAtual != NULL)
         {
		NoLista* pVelho = pAtual;
		pAtual = pAtual->prox;
		delete pVelho;
          }
        } // destrutor da lista

//! Metodo queverificasechaveestnalista,
/*!
	@param chave Elemento procurado
	@return 1casoencontree0casonoencontre
*/
int ListaEnc::Busca (int chave ){

	if ( ptlista == NULL ) return false; //lista vazia
	//!cria um ponteiro apontado para o primeiro no para percorrer a lista
	NoLista* pt = ptlista; 
	
	while (pt != NULL) {
		
		if (pt->chave == chave) return true; //achou a chave e encerra a busca
		
		else pt =pt->prox; //nao achou, passa para o proximo da lista
	
	}
	//chegouaqui,significaquenaoachouonoprocurado
	return false;
}

//!  Metodo para esvaziar a lista
void ListaEnc::limpar(){
		ptlista->chave=0;
		ptlista->prox =NULL;
  }
  
//!  Metodo de insercao na lista, a busca e feita entes da insercao.
//! @param chave O elemento a ser inserido.
int ListaEnc::inserir( int chave ) {
	
	if ( Busca(chave) ) return false; // a chave ja esta na lista
		//!Criacao de um ponteiro auxiliar.
		NoLista *pt;
		//! Aponta para o ultimo elemento da lista
		NoLista *pAnt=NULL;
		try { pt = new NoLista[2]; }
		catch ( const bad_alloc& e ) {
		// Aqui dentro vai a acao a ser tomada.
		cerr << "\n[listaenc::inserir(int)]: Erro durante alocacao da area de armazenamento!\n";
		// Aborta o programa, usado apenas em testes.
		assert ( false );
		}
		
		pt->chave=chave;//recebe o valor da chave
		
		if (ptlista==NULL){
			try { ptlista = new NoLista[2]; }
			catch ( const bad_alloc& e ) {
			// Aqui dentro vai a acao a ser tomada.
			cerr << "\n[listaenc::inserir(int)]: Erro durante alocacao da area de armazenamento!\n";
			// Aborta o programa, usado apenas em testes.
			assert ( false );
			}
			ptlista=pt; //novo inicio da lista
		}
		else{
			NoLista * pAtual=ptlista;
			while(pAtual!=NULL){// laco para guardar o ultimo elemento da lista (guardado em pAnt)
				pAnt=pAtual;
				pAtual=pAtual->prox;
			}
			pAnt->prox=pt; //o ultimo elemento aponta para o novo elemento inserido
		}
		return(EXIT_SUCCESS);
	}
	
//!  Metodo de remocao da primeira chave da lista.
/*! @return elemento removido
*/
int ListaEnc::removerseq()//remove o elemento especificado
{
		//! No auxiliar para retorno
		NoLista* Aux;
		Aux=ptlista;
		ptlista=ptlista->prox;		
		return Aux->chave;

}
 
//!  Metodo de remocao de um elemento na lista, a busca e feita entes da insercao.
/*! @param chave O elemento a ser removido.
     @return false se a chave nao esta na lista, caso contrario remove o elemento e retorna true.
*/
int ListaEnc::remover(int chave)//remove o elemento especificado
{
        if ( !Busca(chave) ) return false;//a chave nao esta na lista
	
	else{
		//! No que recebe a posicao inicial
		NoLista* pAtual = ptlista; //salva primeiro
		//! Aponta para o ponteiro anterior
		NoLista *pAnt=NULL;
		
		while(pAtual !=NULL && pAtual->chave < chave)
		{
			     pAnt=pAtual;
			     pAtual = pAtual->prox; // percorre at achar o elemento
			     }
		pAnt->prox=pAtual->prox;
		delete pAtual;
		return true; // encontrou
	}
}
  
//!  Metodo para testar se a lista esta vazia.
/*! @return true se vazia, false caso contrario.
*/
int ListaEnc::isEmpty()
{
	if (ptlista==NULL) return true;
	else return false;
}
	
 void ListaEnc::ExibirLista()
{
	cout << "Lista Encadeada: ";
	 //! primeiro n da lista
	NoLista* pAtual = ptlista;
	while(pAtual != NULL){ // at o fim da lista

		pAtual->display(); // exibe os dados do n
		pAtual = pAtual->prox; //move para proximo n
	}
     cout<<endl;
 }
