/*!
 <PRE>
 SOURCE FILE : orca.cpp
 DESCRIPTION.: Algoritmo que realiza o processo de ordenacao por distribuicao de chaves
			Calcula ate 3 digitos nas bases binaria, octal e decimal.
 AUTHOR......: Raul Joaquim Camara dos Santos
 LOCATION....: DIMAp/UFRN.
 STARTED ON.: Setembro/2007

 TO COMPILE..: g++ -Wall orca.cpp -o orca
 LAST UPDATE.: 19 de setembro de 2007.
 </pre>
*/
/* ========================================================================= */
/* INCLUDES   	 				                             */
/* ------------------------------------------------------------------------- */
#include "listaenc.cpp"
#include "queue.h"
using namespace MyQueue;
#include<fstream>
#include<stdlib.h>

#define DEFAULT_SIZE 256
	
//! @fn int main() 
/*! @brief Funcao principal que recebe os valores de um arquivo txt e armazena na lista.
	Apos iteracoes, a lista e ordenada.
*/
int main()
{
	// Criacao de todas as filas. O uso delas depende da base escolhida
	//! Criacao da fila 0
	Queue<int> queue0(DEFAULT_SIZE);
	//! Criacao da fila 1
	Queue<int> queue1(DEFAULT_SIZE);
	//! Criacao da fila 2
	Queue<int> queue2(DEFAULT_SIZE);
	//! Criacao da fila 3
	Queue<int> queue3(DEFAULT_SIZE);
	//! Criacao da fila 4
	Queue<int> queue4(DEFAULT_SIZE);
	//! Criacao da fila 5
	Queue<int> queue5(DEFAULT_SIZE);
	//! Criacao da fila 6
	Queue<int> queue6(DEFAULT_SIZE);
	//! Criacao da fila 7
	Queue<int> queue7(DEFAULT_SIZE);
	//! Criacao da fila 8
	Queue<int> queue8(DEFAULT_SIZE);
	//! Criacao da fila 9
	Queue<int> queue9(DEFAULT_SIZE);
	//! espaco reservado para armazenamento da linha
	char linha[DEFAULT_SIZE];
	//! declaracao da lista encadeada
	ListaEnc lista;
	//! variavel que le a base apartir do arquivo txt 
	char base;
	//!ponteiro que guarda os valores nas posicoes da linha do arquivo txt
	char * valor;
	//! variavel que recebe cada posicao das linhas do arquivo
	char symb;
	//! posicao da linha
	int plinha=0;
	//! variavel auxiliar para armazenaento dos numeros
	bool insidenum=false;
	//! posicao na linha do numero atual
	int begin_num = 0;
	//! char convertido em numero
	int num_lido;
	//! elemento da lista
	int elem_lido;
	//!auxiliar para elem-lido
	int elem;
	//! posicao dos digitos dos valores da lista
	int casa=0;
	//! valor do digito da posicao lida
	int pos;
	//! valor da base (binaria, octal ou decimal)
	int ValorBase;
	//! numero de digitos(inicialmente com 2 digitos)
	int digi;
	
	//leitura das linhas inseridas pelo usuario
	while(cin.getline(linha, DEFAULT_SIZE)) {
		
		valor = linha;
		//recebe a primeira linha que contem a base 
		if (plinha==0 && strlen(linha) != 0)
		{	
			base = linha[1];
			if (base=='0'){
				cout<<"A base e >1"<<base<<"<"<<endl;
				ValorBase=10;
			}
			else if(base=='2'){
				cout<<"A base e >0"<<base<<"<"<<endl;
				ValorBase=2;
			}	
			else if(base=='8'){
				cout<<"A base e >0"<<base<<"<"<<endl;
				ValorBase=8;
			}
			plinha++;
			continue;
		}
				
		//percorre as chaves da lista
				for(int i = 0; i < DEFAULT_SIZE; i++)
				{
					
					symb = linha[i];
					
					if (isdigit(symb)) {
						if(!insidenum) {
							begin_num = i;
							insidenum = true;
						}
					}
					else {
					// acabo de sair de um numero (ou sejanumero recebido por completo)
													
						digi = i - begin_num; //recebe a quantidade de digitos.
						
						if (insidenum) {
							
							num_lido = atoi(valor+begin_num); //transforma a posicao onde se encontra o valor em um inteiro
							insidenum = false; //passo para a volta a procura de um novo numero
							lista.inserir(num_lido);//insere o numero na lista
								
						}
					}
					if (linha[i] == '\0' ) break; //saida no final da leitura da linha
				}
					//impressao da primeira lista
					lista.ExibirLista();
				
				while (casa!=digi){
					//passagem dos valores da lista para as pilhas
					while (!lista.isEmpty()){
						
						elem_lido=lista.removerseq();
						if (casa==0)
							pos = elem_lido%ValorBase; //recebe a pos dos valores (primeiro digito)
						else if(casa==1){
							if (digi==2 && elem_lido>=100) {
								cerr<<">> ERRO NO PROGRAMA. Inconsistencia no numero de digitos"<<endl;
								return (EXIT_FAILURE);
							}
							elem=elem_lido;
							if (elem_lido>100) { elem=elem_lido%100; }//auxilio a ordenacao caso o numero seja maior que 100
							pos = ( elem - elem%ValorBase )/ValorBase; //calculo para receber o proximo digito de maior importancia
						}
						else
							pos = ( elem_lido - elem_lido%(ValorBase*10) )/(ValorBase*10); //calculo para receber o proximo digito de maior importancia
						//insercao dos valores em cada pilha
						if  (pos==0){ //usei o if porque o switch tava frescando
							queue0.enqueue(elem_lido);
						}
						else if (pos==1){
							queue1.enqueue(elem_lido);
						}
						else if (pos==2){
							queue2.enqueue(elem_lido);
						}
						else if (pos==3){
							queue3.enqueue(elem_lido);
						}
						else if (pos==4){
							queue4.enqueue(elem_lido);
						}
						else if (pos==5){
							queue5.enqueue(elem_lido);
						}
						else if (pos==6){
							queue6.enqueue(elem_lido);
						}
						else if (pos==7){
							queue7.enqueue(elem_lido);
						}
						else if (pos==8){
							queue8.enqueue(elem_lido);
						}
						else{
							queue9.enqueue(elem_lido);
						}
					}
				
					//impressao das filas
					cout<<"\nF0: ";
					queue0.print();
					cout<<"\nF1: ";
					queue1.print();
					cout<<"\nF2: ";
					queue2.print();
					cout<<"\nF3: ";
					queue3.print();
					cout<<"\nF4: ";
					queue4.print();
					cout<<"\nF5: ";
					queue5.print();
					cout<<"\nF6: ";
					queue6.print();
					cout<<"\nF7: ";
					queue7.print();
					cout<<"\nF8: ";
					queue8.print();
					cout<<"\nF9: ";
					queue9.print();
					
					//insercao na lista e esvaziamento de cada pilha
					while( !queue0.isEmpty() ){
						lista.inserir(queue0.front());
						queue0.dequeue();
					}
					while( !queue1.isEmpty() ){
						lista.inserir(queue1.front());
						queue1.dequeue();
					}
					while( !queue2.isEmpty() ){
						lista.inserir(queue2.front());
						queue2.dequeue();
					}
					while( !queue3.isEmpty() ){
						lista.inserir(queue3.front());
						queue3.dequeue();
					}
					while( !queue4.isEmpty() ){
						lista.inserir(queue4.front());
						queue4.dequeue();
					}
					while( !queue5.isEmpty() ){
						lista.inserir(queue5.front());
						queue5.dequeue();
					}
					while( !queue6.isEmpty() ){
						lista.inserir(queue6.front());
						queue6.dequeue();
					}
					while( !queue7.isEmpty() ){
						lista.inserir(queue7.front());
						queue7.dequeue();
					}
					while( !queue8.isEmpty() ){
						lista.inserir(queue8.front());
						queue8.dequeue();
					}
					while( !queue9.isEmpty() ){
						lista.inserir(queue9.front());
						queue9.dequeue();
					}
					cout<<endl;
					lista.ExibirLista();//impressao da lista
				casa++;//passagem para o proximo digito
				}
		
	}	
}
	
